# Copyright 2020 StrongDM Inc
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from . import approval_workflow_approvers_pb2 as approval__workflow__approvers__pb2


class ApprovalWorkflowApproversStub(object):
    """ApprovalWorkflowApprovers link approval workflow approvers to an ApprovalWorkflowStep
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Create = channel.unary_unary(
                '/v1.ApprovalWorkflowApprovers/Create',
                request_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverCreateRequest.SerializeToString,
                response_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverCreateResponse.FromString,
                )
        self.Get = channel.unary_unary(
                '/v1.ApprovalWorkflowApprovers/Get',
                request_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverGetRequest.SerializeToString,
                response_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverGetResponse.FromString,
                )
        self.Delete = channel.unary_unary(
                '/v1.ApprovalWorkflowApprovers/Delete',
                request_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverDeleteRequest.SerializeToString,
                response_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverDeleteResponse.FromString,
                )
        self.List = channel.unary_unary(
                '/v1.ApprovalWorkflowApprovers/List',
                request_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverListRequest.SerializeToString,
                response_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverListResponse.FromString,
                )


class ApprovalWorkflowApproversServicer(object):
    """ApprovalWorkflowApprovers link approval workflow approvers to an ApprovalWorkflowStep
    """

    def Create(self, request, context):
        """Create creates a new approval workflow approver.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Get(self, request, context):
        """Get reads one approval workflow approver by ID.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Delete(self, request, context):
        """Delete deletes an existing approval workflow approver.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def List(self, request, context):
        """Lists existing approval workflow approvers.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_ApprovalWorkflowApproversServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'Create': grpc.unary_unary_rpc_method_handler(
                    servicer.Create,
                    request_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverCreateRequest.FromString,
                    response_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverCreateResponse.SerializeToString,
            ),
            'Get': grpc.unary_unary_rpc_method_handler(
                    servicer.Get,
                    request_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverGetRequest.FromString,
                    response_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverGetResponse.SerializeToString,
            ),
            'Delete': grpc.unary_unary_rpc_method_handler(
                    servicer.Delete,
                    request_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverDeleteRequest.FromString,
                    response_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverDeleteResponse.SerializeToString,
            ),
            'List': grpc.unary_unary_rpc_method_handler(
                    servicer.List,
                    request_deserializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverListRequest.FromString,
                    response_serializer=approval__workflow__approvers__pb2.ApprovalWorkflowApproverListResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'v1.ApprovalWorkflowApprovers', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class ApprovalWorkflowApprovers(object):
    """ApprovalWorkflowApprovers link approval workflow approvers to an ApprovalWorkflowStep
    """

    @staticmethod
    def Create(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.ApprovalWorkflowApprovers/Create',
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverCreateRequest.SerializeToString,
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverCreateResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Get(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.ApprovalWorkflowApprovers/Get',
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverGetRequest.SerializeToString,
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverGetResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Delete(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.ApprovalWorkflowApprovers/Delete',
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverDeleteRequest.SerializeToString,
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverDeleteResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def List(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.ApprovalWorkflowApprovers/List',
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverListRequest.SerializeToString,
            approval__workflow__approvers__pb2.ApprovalWorkflowApproverListResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
