# Copyright 2020 StrongDM Inc
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from . import peering_group_resources_pb2 as peering__group__resources__pb2


class PeeringGroupResourcesStub(object):
    """PeeringGroupResources provides the building blocks necessary to obtain attach a resource to a peering group.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Create = channel.unary_unary(
                '/v1.PeeringGroupResources/Create',
                request_serializer=peering__group__resources__pb2.PeeringGroupResourceCreateRequest.SerializeToString,
                response_deserializer=peering__group__resources__pb2.PeeringGroupResourceCreateResponse.FromString,
                )
        self.Delete = channel.unary_unary(
                '/v1.PeeringGroupResources/Delete',
                request_serializer=peering__group__resources__pb2.PeeringGroupResourceDeleteRequest.SerializeToString,
                response_deserializer=peering__group__resources__pb2.PeeringGroupResourceDeleteResponse.FromString,
                )
        self.Get = channel.unary_unary(
                '/v1.PeeringGroupResources/Get',
                request_serializer=peering__group__resources__pb2.PeeringGroupResourceGetRequest.SerializeToString,
                response_deserializer=peering__group__resources__pb2.PeeringGroupResourceGetResponse.FromString,
                )
        self.List = channel.unary_unary(
                '/v1.PeeringGroupResources/List',
                request_serializer=peering__group__resources__pb2.PeeringGroupResourceListRequest.SerializeToString,
                response_deserializer=peering__group__resources__pb2.PeeringGroupResourceListResponse.FromString,
                )


class PeeringGroupResourcesServicer(object):
    """PeeringGroupResources provides the building blocks necessary to obtain attach a resource to a peering group.
    """

    def Create(self, request, context):
        """Create attaches a Resource to a PeeringGroup
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Delete(self, request, context):
        """Delete detaches a Resource to a PeeringGroup
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Get(self, request, context):
        """Get reads the information of one peering group to resource attachment.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def List(self, request, context):
        """List gets a list of peering group resource attachments.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_PeeringGroupResourcesServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'Create': grpc.unary_unary_rpc_method_handler(
                    servicer.Create,
                    request_deserializer=peering__group__resources__pb2.PeeringGroupResourceCreateRequest.FromString,
                    response_serializer=peering__group__resources__pb2.PeeringGroupResourceCreateResponse.SerializeToString,
            ),
            'Delete': grpc.unary_unary_rpc_method_handler(
                    servicer.Delete,
                    request_deserializer=peering__group__resources__pb2.PeeringGroupResourceDeleteRequest.FromString,
                    response_serializer=peering__group__resources__pb2.PeeringGroupResourceDeleteResponse.SerializeToString,
            ),
            'Get': grpc.unary_unary_rpc_method_handler(
                    servicer.Get,
                    request_deserializer=peering__group__resources__pb2.PeeringGroupResourceGetRequest.FromString,
                    response_serializer=peering__group__resources__pb2.PeeringGroupResourceGetResponse.SerializeToString,
            ),
            'List': grpc.unary_unary_rpc_method_handler(
                    servicer.List,
                    request_deserializer=peering__group__resources__pb2.PeeringGroupResourceListRequest.FromString,
                    response_serializer=peering__group__resources__pb2.PeeringGroupResourceListResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'v1.PeeringGroupResources', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class PeeringGroupResources(object):
    """PeeringGroupResources provides the building blocks necessary to obtain attach a resource to a peering group.
    """

    @staticmethod
    def Create(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.PeeringGroupResources/Create',
            peering__group__resources__pb2.PeeringGroupResourceCreateRequest.SerializeToString,
            peering__group__resources__pb2.PeeringGroupResourceCreateResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Delete(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.PeeringGroupResources/Delete',
            peering__group__resources__pb2.PeeringGroupResourceDeleteRequest.SerializeToString,
            peering__group__resources__pb2.PeeringGroupResourceDeleteResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Get(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.PeeringGroupResources/Get',
            peering__group__resources__pb2.PeeringGroupResourceGetRequest.SerializeToString,
            peering__group__resources__pb2.PeeringGroupResourceGetResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def List(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.PeeringGroupResources/List',
            peering__group__resources__pb2.PeeringGroupResourceListRequest.SerializeToString,
            peering__group__resources__pb2.PeeringGroupResourceListResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
